'****************************************************************
'*  Name    : MCP23S08-SPI.BAS                                      *
'*  Author  : [ALEX-ALMATY]                    *
'*  Notice  : Copyright (c) 2015 [select VIEW...EDITOR OPTIONS] *
'*          : All Rights Reserved                               *
'*  Date    : 07.01.2015                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
     Device = 16F876A	
Xtal = 4   '    4 


'  \\\\
Declare  LCD_Type ALPHA        '   216
Declare  LCD_DTPin  PORTB.4    ' 4    ,      4  
Declare  LCD_ENPin  PORTB.3    '     
Declare  LCD_RSPin  PORTB.2    '    
Declare  LCD_Interface  4      '    ( 4  8  )
Declare  LCD_CommandUs  200    '    
Declare  LCD_DataUs  50        '    
Declare  LCD_Lines   2
All_Digital = On                 '    (  )

TRISC = %00000000
PORTB = %00000000
TRISB = %00000001
PORTC = %00010000
TRISA = %11111111
PORTA = %00000000

Dim x As Byte
Dim y As Byte




 
Symbol cs_pin  = PORTC.6   '               
Symbol CLK =     PORTC.3   ' - 
Symbol DTAOUT =  PORTC.5   '     
Symbol DTAIN =   PORTC.4   '    Ȩ 

Cls
Print At 1,1, "SPI-PIC16F876-"
Print At 2,4, "-MCP23S08"
DelayMS 1000
'   
main:
PORTC.4 = 1
If PORTA.0 = 0 Then GoSub IN
GoSub OUT
GoTo main
End
'    (   )
OUT:  
Low cs_pin  '     
SHOut DTAOUT, CLK, MsbFirst,[%01000000,%00000000,%00000000] '   -  - -  -  (7_ - 8       )- -  .
High cs_pin '    
DelayMS 100 
Low cs_pin 
SHOut DTAOUT, CLK, MsbFirst,[%01000000,%00001001,%11111111] '
High cs_pin
DelayMS 100
Low cs_pin
SHOut DTAOUT, CLK, MsbFirst,[%01000000,%00001001,%01010101] '
High cs_pin
DelayMS 100
Low cs_pin
SHOut DTAOUT, CLK, MsbFirst,[%01000000,%00000000,%11111111] '
High cs_pin
DelayMS 100
Return
'
IN:
x = 0
Low cs_pin
SHOut DTAOUT, CLK, MsbFirst,[%01000001,%00001001] '   -  (09h GPIO)     
SHIn DTAIN, CLK, MsbPre,[x]                       '   Ȩ -    Ȩ--    Ȩ-        
High cs_pin
GoSub print_x
Return
'               
print_x:
Cls
Print At 1,1, "ADR-09h GPIO-"
Print At 2,4, Bin x, "  "
DelayMS 2000
Cls
Print At 1,1, "SPI-PIC16F876-"
Print At 2,4, "-MCP23S08"
DelayMS 1000
GoTo main








